[![Build Status](https://travis-ci.org/dsmorse/gridster.js.svg)](http://travis-ci.org/dsmorse/gridster.js)
[![GitHub version](https://badge.fury.io/gh/dsmorse%2Fgridster.js.svg)](http://dsmorse.github.io/gridster.js/)
[![Built with Grunt](https://cdn.gruntjs.com/builtwith.png)](http://gruntjs.com/)
[![Gem Version](https://badge.fury.io/rb/gridster.js-rails.svg)](https://rubygems.org/gems/gridster.js-rails)
[![Bower version](https://badge.fury.io/bo/gridster-js.svg)](http://bower.io/search/?q=gridster-js)

Gridster.js
===========

Gridster is a jQuery plugin that makes building intuitive draggable
layouts from elements spanning multiple columns. You can even
dynamically add and remove elements from the grid.

More at [http://gridster.net/](http://gridster.net/).

### Live Preview at: [http://dsmorse.github.io/gridster.js/](http://dsmorse.github.io/gridster.js/)

[Releases](https://github.com/dsmorse/gridster.js/releases)

[CHANGELOG](https://github.com/dsmorse/gridster.js/blob/master/CHANGELOG.md)

Gridster was created by Ducksboard but they have basiclly abondoned the project
and even those who had write permissions to the repo are not merging pull requests.

## Forks

As of result of the inactivity over the last year in the [Ducksboard](https://github.com/ducksboard/gridster.js) repository, [@dsmorse](https://github.com/dsmorse/gridster.js) has created a fork
for current support.  He will GLADLY accept pull requests, and will be working to merge existing
Pull Requests from Ducksboard repo.

## Install with NPM

This fork of Gridster can be installed via [NPM](https://npmjs.com/package/dsmorse-gridster);

```
npm install dsmorse-gridster
```

or to save.

```
npm install dsmorse-gridster --save
```

## Ruby on Rails integration

This artifact is published to [rubygems.org](https://rubygems.org/gems/gridster.js-rails) to be consumed by ruby on rails applications.

Include gridster.js-rails in Gemfile;

``` ruby
gem 'gridster.js-rails'
```

and run bundle install.

### Configuration

Add this line to app/assets/stylesheets/application.css

``` css
 *= require jquery.gridster
```

Add this line to app/assets/javascripts/application.js

``` javascript
//= require jquery.gridster
```

## Contributing to this project

Anyone and everyone is welcome to contribute. Please take a moment to review the guidelines for contributing.

* [Bug reports](CONTRIBUTING.md#bugs)
* [Feature requests](CONTRIBUTING.md#features)
* [Pull requests](CONTRIBUTING.md#pull-requests)


## License

Distributed under the MIT license.

## Whodunit

Gridster is built by [Ducksboard](http://ducksboard.com/) with the help of all
these [wonderful people](https://github.com/ducksboard/gridster.js/graphs/contributors).
